clear
close all
clc

%% Task 1

% Generate 100-Hz sine wave x(n) sampled with fs = 44.1kHz
f_s   	= 44100;
f_0    	= 100;
N       = 1024;
n       = 0 : N-1;
x       = sin(2*pi*f_0/f_s*n);

% 3bit-Quantizer
w       = 3;
Q       = 2^(-(w-1));

% Truncation
x_qt   	= Q * floor(x/Q); 
e_t     = x - x_qt;

% Rounding
x_qr    = Q * floor((x/Q)+0.5); 
e_r     = x - x_qr;

figure;
% Show Truncation
subplot(2,1,1)
plot(n,x,'k'); hold on;
plot(n,x_qt,'b'); 
plot(n,e_t,'r'); hold off;
grid on;
xlim([0 N-1]); ylim([-1 1]);
title('Truncation');
xlabel('n'); ylabel('x(n)');
legend('x(n)','x_{Q,t}(n)','e_{t}(n)');
% Show Rounding
subplot(2,1,2)
plot(n,x,'k'); hold on;
plot(n,x_qr,'b'); 
plot(n,e_r,'r'); hold off;
grid on;
xlim([0 N-1]); ylim([-1 1]);
title('Rounding');
xlabel('n'); ylabel('x(n)');
legend('x(n)','x_{Q,r}(n)','e_{r}(n)');
