clear
close all
clc

%% Task 4 
w           = 16;                               
Q           = 2^(1-w);                  
NFFT        = 16*1024;                      
f_s         = 44100;

% Rectangular dither
r1          = 2 * rand(1,NFFT) - 1;
d_rect      = r1 * Q/2; 

% Triangular Dither 
r2          = 2 * rand(1,NFFT) - 1;
d_tri       = (r1+r2) * Q/2;

% High pass Dither
r1_delayed  = [0 r1(1:NFFT-1)];
d_tri_HP    = (r1-r1_delayed) * Q/2;

%% Task 5

f_vec               = (0:(NFFT-1)) / NFFT * f_s;
[n_hist1, d_hist1]  = hist(d_rect, 11);
D_rect              = fft(d_rect,NFFT);
[n_hist2, d_hist2]  = hist(d_tri, 21);
D_tri               = fft(d_tri,NFFT);
[n_hist3, d_hist3]  = hist(d_tri_HP, 21);
D_tri_HP            = fft(d_tri_HP,NFFT);

figure;
% Rectangular Dither
subplot(2,3,1);
bar(d_hist1/Q, 100*n_hist1/sum(n_hist1));
xlim([-1 1]); ylim([0 10]);
xlabel('d_{rect}/Q'); ylabel('Relative frequency in %');
title('rectangular dither');
subplot(2,3,4);
plot(f_vec, 20*log10(abs(D_rect)));
xlim([0 f_s/2]); ylim([-120 -40]); grid on;
xlabel('f'); ylabel('|D_{rect}(f)| in dB');
% Triangular Dither
subplot(2,3,2);
bar(d_hist2/Q, 100*n_hist2/sum(n_hist2));
xlim([-1 1]); ylim([0 10]);
xlabel('d_{tri}/Q'); ylabel('Relative frequency in %');
title('triangular dither');
subplot(2,3,5);
plot(f_vec, 20*log10(abs(D_tri)));
xlim([0 f_s/2]); ylim([-120 -40]); grid on;
xlabel('f'); ylabel('|D_{tri}(f)| in dB');
% Triangular Highpass Dither
subplot(2,3,3);
bar(d_hist3/Q, 100*n_hist3/sum(n_hist3));
xlim([-1 1]); ylim([0 10]);
xlabel('d_{triHP}/Q'); ylabel('Relative frequency in %');
title('triangular dither');
subplot(2,3,6);
plot(f_vec, 20*log10(abs(D_tri_HP)));
xlim([0 f_s/2]); ylim([-120 -40]); grid on;
xlabel('f'); ylabel('|D_{triHP}(f)| in dB');
